//some variables to store the pins we are using and the distance

int pinOut  = 5;          //this is the pin we use for the triggering of the reading.
int pinIn   = 7;          //this is the pin we use for the sonar reading

unsigned long  lengthCM;  //the distance - we divide this later by 29 to get a rough value in cm

//only happens once
void setup(){
    //lets setup the two pins we will use for our sonar device
    pinMode(pinOut, OUTPUT);    //this triggers the reading of the distance - so we set to OUTPUT
    pinMode(pinIn, INPUT);      //this gets back the distance - so we set to INPUT

    //enable serial communication back to the computer
    Serial.begin(9600);	   
}

//runs all the time
void loop(){
    
    //the trigger signal
    digitalWrite(pinOut, HIGH);
    delayMicroseconds(10);
    digitalWrite(pinOut, LOW);    
    
    //lets read the distance
    lengthCM = pulseIn(pinIn, HIGH) / 29;  //we divide by 29 as this will give us a value in cm
  
    
    int val = Serial.read();
    
    if (val != -1) {
      if (val == '!') {
        
        unsigned char val1;
        unsigned char val2;
       
        val1 =  lengthCM &0xFF;
        val2 = (lengthCM >> 8) &0xFF; 
        
        Serial.print(val1, BYTE);
        Serial.print(val2, BYTE);
        //wait a little bit so we don't send too much data 
        delay(80);
      }
    }
  
}
